From a322a9060aaec543c73165291e91afe04c200a0f Mon Sep 17 00:00:00 2001
From: Aurélien Bompard <aurelien@bompard.org>
Date: Feb 09 2017 15:54:10 +0000
Subject: [PATCH 702/1001] Add a CachedFunction class


This class is a wrapper for a function that will cache its results until a
relevant message is emitted on the bus.

---

diff --git a/hubs/tests/__init__.py b/hubs/tests/__init__.py
index 2394c1e..d761381 100644
--- a/hubs/tests/__init__.py
+++ b/hubs/tests/__init__.py
@@ -35,7 +35,7 @@ class APPTest(unittest.TestCase):
         self.app = hubs.app.app.test_client()
         self.app.testing = True
         self.session = hubs.app.session
-        from hubs.widgets.base import cache
+        from hubs.widgets.caching import cache
         cache.configure(backend='dogpile.cache.null',
                         replace_existing_backend=True)
         self.populate()
diff --git a/hubs/tests/test_widget_caching.py b/hubs/tests/test_widget_caching.py
new file mode 100644
index 0000000..967db0e
--- /dev/null
+++ b/hubs/tests/test_widget_caching.py
@@ -0,0 +1,73 @@
+from __future__ import unicode_literals
+
+from hubs.widgets.caching import cache, CachedFunction
+
+from mock import Mock
+from hubs.tests import APPTest
+from hubs.models import Hub, Widget
+
+
+class DummyFunction(CachedFunction):
+
+    def __init__(self, *args, **kwargs):
+        super(DummyFunction, self).__init__(*args, **kwargs)
+        self.execute_mock = Mock()
+
+    def execute(self, *args, **kwargs):
+        return self.execute_mock(*args, **kwargs)
+
+
+class CachedFunctionTest(APPTest):
+
+    def setUp(self):
+        super(CachedFunctionTest, self).setUp()
+        # Use a memory backend, not the default null backend, or we can't test
+        # anything.
+        cache.configure(backend='dogpile.cache.memory',
+                        replace_existing_backend=True)
+        self.w_instance = Widget.query.filter(
+            Hub.name == "ralph",
+            Widget.plugin == "about",
+            ).one()
+        self.fn = DummyFunction(self.w_instance)
+        cache.delete(self.fn.get_cache_key())
+
+    def tearDown(self):
+        cache.delete(self.fn.get_cache_key())
+        super(CachedFunctionTest, self).tearDown()
+
+    def test_get_cache_key(self):
+        self.assertEqual(
+            self.fn.get_cache_key(),
+            b"%d|DummyFunction" % self.w_instance.idx
+            )
+
+    def test_result_cached(self):
+        self.fn.execute_mock.return_value = "testing"
+        result = self.fn()
+        self.fn.execute_mock.assert_called_once_with()
+        self.assertEqual(result, "testing")
+        result = self.fn()
+        self.assertEqual(result, "testing")
+        # Check it hasn't been called a second time.
+        self.fn.execute_mock.assert_called_once()
+
+    def test_is_cached(self):
+        key = self.fn.get_cache_key()
+        self.assertFalse(self.fn.is_cached())
+        cache.set(key, "testing is_cached")
+        self.assertTrue(self.fn.is_cached())
+
+    def test_invalidate(self):
+        key = self.fn.get_cache_key()
+        cache.set(key, "testing invalidate")
+        self.fn.invalidate()
+        self.assertFalse(self.fn.is_cached())
+
+    def test_rebuild(self):
+        key = self.fn.get_cache_key()
+        cache.set(key, "testing rebuild")
+        self.fn.execute_mock.return_value = "testing"
+        self.fn.rebuild()
+        self.fn.execute_mock.assert_called_once()
+        self.assertEqual(cache.get(key), "testing")
diff --git a/hubs/widgets/caching.py b/hubs/widgets/caching.py
new file mode 100644
index 0000000..2eded91
--- /dev/null
+++ b/hubs/widgets/caching.py
@@ -0,0 +1,147 @@
+"""
+Attributes:
+    cache (dogpile.cache.region.CacheRegion): The cache where function results
+        will be stored. It is configured with the `fedora-hubs.cache` key in
+        fedmsg configuration.
+"""
+from __future__ import unicode_literals
+
+import datetime
+import dogpile
+import dogpile.cache
+import fedmsg.config
+import logging
+
+log = logging.getLogger(__name__)
+
+
+def _get_cache():
+    config = fedmsg.config.load_config()
+    cache_defaults = {
+        "backend": "dogpile.cache.dbm",
+        "expiration_time": 1,  # Expire every 1 second, for development
+        "arguments": {
+            "filename": "/var/tmp/fedora-hubs-cache.db",
+        },
+    }
+    cache = dogpile.cache.make_region()
+    cache.configure(**config.get('fedora-hubs.cache', cache_defaults))
+    return cache
+
+cache = _get_cache()
+
+
+class CachedFunction(object):
+    """
+    A function that has automatic caching and invalidation features.
+
+    This class is a wrapper for a function that will cache its results until a
+    relevant message is emitted on the bus.
+
+    To use this class, you must subclass it and implement a couple methods.
+    It is instantiated by passing a widget instance (database record) as only
+    argument, which lets it access the `.config` property and act accordingly.
+
+    You must implement the `execute()` method, which must return a
+    JSON-serializable value.
+
+    You must also implement the `should_invalidate()` method, which takes the
+    bus message as only argument, and returns `True` if the cache should be
+    rebuild, `False` otherwise.
+
+    To call the function, instanciate the class and execute it. You may also
+    call the `.get_data()` method.
+
+    Args:
+        instance (hubs.models.Widget): The widget instance.
+    """
+
+    # invalidate_filter = {}
+
+    def __init__(self, instance):
+        self.instance = instance
+
+    def execute(self):
+        """
+        The function to cache.
+
+        This is the main method, it must be implemented.
+
+        Returns:
+            dict or list: A JSON-serializable value that will be cached.
+        """
+        raise NotImplementedError
+
+    def get_cache_key(self):
+        return "|".join([
+            str(self.instance.idx),
+            self.__class__.__name__,
+        ]).encode('utf-8')
+
+    def get_data(self):
+        key = self.get_cache_key()
+        # log.debug("Accessing cache key %s", key)
+        return cache.get_or_create(
+            key, lambda: self.execute())
+
+    __call__ = get_data
+
+    # def _get_topic(self, message):
+    #     return message['topic']
+
+    # def _get_category(self, message):
+    #     return message['topic'].split('.')[3]
+
+    # def pass_filter(self, message):
+    #     topic_filter = self.invalidate_filter.get("topic")
+    #     if topic_filter and self._get_topic(message) not in topic_filter:
+    #         return False
+    #     category_filter = self.invalidate_filter.get("category")
+    #     if category_filter and \
+    #             self._get_category(message) not in category_filter:
+    #         return False
+    #     return True
+
+    def should_invalidate(self, message):
+        """
+        Tell the cache invalidator if the received message should invalidate
+        this function's cache.
+
+        Args:
+            message (dict): The recieved bus message.
+
+        Returns:
+            bool: If `True`, the cache will be rebuilt.
+        """
+        # if not self._pass_filter(message):
+        #     return False
+        return True
+
+    def is_cached(self):
+        """
+        Return a boolean indicating if the function's result is currently in the cache.
+
+        Returns:
+            bool: Whether the cache currently contains the function result.
+        """
+        result = cache.get(self.get_cache_key(), ignore_expiration=True)
+        return not isinstance(result, dogpile.cache.api.NoValue)
+
+    def invalidate(self):
+        """
+        Invalidate this function's cache.
+        """
+        key = self.get_cache_key()
+        if not self.is_cached():
+            log.debug("Not deleting cache key %s.  It is absent.", key)
+            return
+        log.debug("Deleting cache key %s.", key)
+        cache.delete(key)
+
+    def rebuild(self):
+        """
+        Rebuild this function's cache.
+        """
+        self.invalidate()
+        self.instance.hub.last_refreshed = datetime.datetime.utcnow()
+        self.get_data()

